
        .XCREF
        .NOLIST
        INCLUDE    \masm32\include\masm32rt.inc
        .586
        INCLUDE    \masm32\macros\timers.asm
        .LIST

;-----------------------------------------------

STATUS_BAR         EQU MF_CHECKED

IDM_FILE_SAVEAS    EQU 1101
IDM_FILE_EXIT      EQU 1102
IDM_EDIT_COPYALL   EQU 1201
IDM_EDIT_COPYFORUM EQU 1202
IDM_FORE_COLOR     EQU 1301
IDM_BACK_COLOR     EQU 1302
IDM_SAVE_SETTINGS  EQU 1303
IDM_VIEW_STATUSBAR EQU 1304
IDM_HELP_HELP      EQU 1401
IDM_HELP_ABOUT     EQU 1402

;-----------------------------------------------

        .DATA

hMenu            dd ?

MenuTable        dd 3                                                       ;'File' menu
                 dd szSaveAs,IDM_FILE_SAVEAS,MF_GRAYED                      ;'Save As...'
                 dd NULL,NULL,MF_SEPARATOR                                  ;MFT_SEPARATOR
                 dd szExit,IDM_FILE_EXIT,MF_STRING                          ;'Exit'
                 dd szFileMenu                                              ;'File'

                 dd 2                                                       ;'Edit' menu
                 dd szCopyAll,IDM_EDIT_COPYALL,MF_GRAYED                    ;'Copy All'
                 dd szCopyForum,IDM_EDIT_COPYFORUM,MF_GRAYED                ;'Copy Forum'
                 dd szEditMenu                                              ;'Edit'

                 dd 6                                                       ;'View' menu
                 dd szForeColor,IDM_FORE_COLOR,MF_STRING                    ;'Foreground Color'
                 dd szBackColor,IDM_BACK_COLOR,MF_STRING                    ;'Background Color'
                 dd NULL,NULL,MF_SEPARATOR                                  ;MFT_SEPARATOR
                 dd szSettings,IDM_SAVE_SETTINGS
ViewState        dd MF_STRING                                               ;'Save Settings'
                 dd NULL,NULL,MF_SEPARATOR                                  ;MFT_SEPARATOR
                 dd szStatusBar,IDM_VIEW_STATUSBAR
StbState         dd STATUS_BAR                                              ;'Status Bar'
                 dd szViewMenu                                              ;'View'

                 dd 3                                                       ;'Help' menu
                 dd szHelpMenu,IDM_HELP_HELP,MF_STRING                      ;'Help'
                 dd NULL,NULL,MF_SEPARATOR                                  ;MFT_SEPARATOR
                 dd szAbout,IDM_HELP_ABOUT,MF_STRING                        ;'About'
                 dd szHelpMenu                                              ;'Help'

szFileMenu       db 'File',0
szEditMenu       db 'Edit',0
szViewMenu       db 'View',0
szHelpMenu       db 'Help',0
szSaveAs         db 'Save As...',0
szExit           db 'Exit',0
szCopyAll        db 'Copy All',0
szCopyForum      db 'Copy Forum',0
szForeColor      db 'Foreground Color',0
szBackColor      db 'Background Color',0
szSettings       db 'Save View Settings',0
szStatusBar      db 'Status Bar',0
szAbout          db 'About',0

;-----------------------------------------------

        .CODE

_main   PROC

        INVOKE  CreateMenu
        mov     hMenu,eax
        push    4
        mov     esi,offset MenuTable
        pop     edi           ;main menu popup count
        xchg    eax,ebx       ;EBX = hMenu

MMenu0: INVOKE  CreatePopupMenu
        push    eax
        lodsd
        xchg    eax,ebp

MMenu1: pop     edx
        lodsd
        push    edx
        push    eax
        lodsd
        push    eax
        lodsd
        push    eax
        push    edx
        CALL    AppendMenu
        dec     ebp
        jnz     MMenu1

        pop     edx
        lodsd
        push    edx
        INVOKE  AppendMenu,ebx,MF_POPUP,edx,eax
        dec     edi
        jnz     MMenu0

        pop     ecx          ;ECX = Help menu handle
        pop     ebp          ;EBP = View menu handle
        pop     edx          ;EDX = Edit menu handle
        pop     eax          ;EAX = File menu handle

;EBX = hMenu
;EDI = 0

        INVOKE  GetConsoleWindow
        INVOKE  SetMenu,eax,ebx
        inkey
        exit

_main   ENDP

;-----------------------------------------------

        END     _main